
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>HAL驱动库学习-SPI / 憋错料</title>

    <meta name="description" content="HAL驱动库学习-SPI 如何使用SPI库1 声明SPI hanlde, 例如: SPI_HandleTypeDef hspi2 通过实现HAL_SPI_MspInit()函数初始化底层资源 以下两个必须进行初始化 a 使能spi时钟 b 配置spi pins 以下根据需要初始化 c NVIC 中断配置 d DMA配置3 配置hspi,包括模式,datasize,baudrate,msb/lsb,crc等4 调用HAL_SPI_Init()函数,初始化spi配置以及底层资源(通过调用HAL_SPI_MspInit())">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">HAL驱动库学习-SPI</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>如何使用SPI库<br />1  声明SPI hanlde， 例如： <code>SPI_HandleTypeDef hspi</code><br />2  通过实现HAL_SPI_MspInit()函数初始化底层资源<br />    以下两个必须进行初始化<br />    a  使能spi时钟<br />    b  配置spi pins<br />    以下根据需要初始化<br />    c  NVIC 中断配置<br />    d  DMA配置<br />3  配置hspi，包括模式，datasize，baudrate，msb/lsb,crc等<br />4  调用HAL_SPI_Init()函数，初始化spi配置以及底层资源（通过调用HAL_SPI_MspInit()）</p>
<p>初始化与配置函数</p>
<pre>
<ol>
<li><code>?  HAL_SPI_Init()</code></li>
<li><code>?  HAL_SPI_DeInit()</code></li>
<li><code>?  HAL_SPI_MspInit()</code></li>
<li><code>?  HAL_SPI_MspDeInit()</code></li>
<li><code>?  HAL_SPI_InitExtended()</code></li>
</ol>
</pre>
<p>备注：<br />      SPI中 datasize可以指定4-16bit数据，在SPI_DR寄存器中无论是字节还是字，数据总是右对齐，通讯时，只有数据字长范围内的位会随时钟输出<br />如下图，左侧只有0--&gt;5位会输出，右侧只有0--&gt;13位会输出<br /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzgxOTAyMS8yMDE1MTEvODE5MDIxLTIwMTUxMTA5MjEzMzExMjQ0LTE2MTEyODQzMzkucG5n.jpg"></p>
<pre>
<ol>
<li><code> 使用单线模式时，主机的MISO，从机的MOSI都可以作为普通IO使用。</code></li>
</ol>
</pre>
<p><a href="http://www.wiz.cn/i/fe8c6f82" rel="external nofollow noreferrer">来自为知笔记(Wiz)</a></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-29 09:38:54 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>HAL驱动库学习-SPI的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/47pm8DM.html" rel="bookmark">HAL驱动库学习-ADC</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				如何使用ADC驱动库 1  实现如下两个函数 a: HAL_ADC_MspInit()使能ADC时钟,设置时钟源, 使能ADC Pin,设置为输入模式,可选 DMA,中断 b:HAL_ADC_MspDeInit() 与 HAL_ADC_MspInit()作用相反,用来关闭ADC,可选 DMA,中断 2  配置ADC参数,详细参数描述参考ADC属性定义.通过HAL_ADC_Init()来加载参数 3  配置ADC通道,包括使用的通道,采样时间等 HAL_ADC_ConfigChannel() 4			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3vOd1R4.html" rel="bookmark">Android深度探索&lpar;卷1&rpar;HAL与驱动开发学习笔记（4）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Android深度探索(卷1)HAL与驱动开发学习笔记(4) 第四章  源代码的下载与编译 一.源代码配置Android源代码下载环境 1.建一个用于存放下载脚本文件(repo)的目录 # mkdir ~/bin # PATH=~.bin:$PATH 2.下载repo脚本文件 # curl https://dl-ssl.google.com/dl/googlesource/git-repo/repo &gt; ~/bin/repo #chmod a+x ~/bin/repo 3.创建用于存放Andro			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/XMm5gVM.html" rel="bookmark">Android深度探索&lpar;卷1&rpar;HAL与驱动开发学习笔记（2）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Android深度探索(卷1)HAL与驱动开发学习笔记(2) 第二章搭建Android开发环境 书中介绍了两种JDK的安装方法, 方法一: 从官网下载JDK并进行配置,解压后在终端打开profile文件来设置PATH环境变量(# soure /etc/profile),打开profile文件后输入下面的内容 export PATH=.:developer/jdk6/bin:$PATH 保存profile文件以后,有两种方法可以重新加载profile文件. 1.# sourse  /etc/pro			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MzyR124.html" rel="bookmark">Android深度探索&lpar;卷1&rpar;HAL与驱动开发学习笔记（7）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Android深度探索(卷1)HAL与驱动开发学习笔记(7) 第七章 控制发光二极管   LED驱动实现原理       2. 编写LED驱动 * 创建LED驱动的设备文件 ·使用cdev_init 函数初始化cdev ·指定设备号 ·使用cdev_add函数将字符设备添加到内核中字符设备组中 ·使用class_creat宏创建stuct class ·使用device_creat 创建设备文件 卸载LED驱动的设备文件 依次调用device_destory.class_destory.unre			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3OK8GX3.html" rel="bookmark">Android深度探索&lpar;卷1&rpar;HAL与驱动开发学习笔记（6）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Android深度探索(卷1)HAL与驱动开发学习笔记(6) 第六章 第一个Linux驱动程序 统计单词个数   Linux系统将每一个驱动都映射成一个文件．这些文件称为设备文件或驱动文件,都保存在/dev目录中.这种设计理念使得与Linux驱动进行交互就像与普通文件进行交互一样容易.虽然C语言里没有事件的概念,但却有与事件类似的概念,这就是回调(c a l l b a c k)函数.因此,编写Lin u x驱动最重要的一步就是编写阴调函数,否则与设备文件交互的数据将无法得到处理. 6.1编写L			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MyXmYp4.html" rel="bookmark">Android深度探索&lpar;卷1&rpar;HAL与驱动开发学习笔记（5）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Android深度探索(卷1)HAL与驱动开发学习笔记(5) 第五章 搭建S3C6410的开发版的测试环境 1.  S3C6410 处理器概述   S3C6410是一个16/32位RISC微处理器,旨在提供一个具有成本效益.功耗低,性能高的应用处理器解决方案,像移动电话和一般的应用.它为2.5G 和 3G通信服务提供优化的H /W性能, S3C6410采用了64/32位内部总线架构.该64/32位内部总线结构由AXI.AHB 和APB总线组成.它还包括许多强大的硬件加速器,像视频处理,音频处理,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3vz6Yg3.html" rel="bookmark">STM32 HAL固件库编程的文件构架</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				对于我这种以前只接触过51和AVR单片机编程的小菜来说,现在开始学习STM32的编程,对于函数的功能以及C语言的语法都还好理解,难的是它提供的那一套硬件抽象层(HAL)驱动是怎么和其他的东东搭配在一起组成一个又一个的工程. 首先上两张从ST官方提供的HAL固件库文档截图 从这两张图的话,能对它的构架看出个一二,下面稍稍具体一点分析 HAL固件库编程,它的文件组织大致分三个部分 - HAL驱动 - CMSIS驱动 - 用户编写程序 而假如你使用的是ST官网的开发板,那么你还有一套现成的驱动可供使用			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MgX2j80.html" rel="bookmark">Android深度探索与HAL驱动开发（卷1）-- 第九章随笔</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第9章 硬件抽象层:HAL Hal(Hardware Abstract Layer,硬件抽象层)是建立在Linux驱动之上的一套程序库.这套程序库并不属于Linux内核,而是属于Linux内核层之上的应用层. 编写支持HAL的Linux驱动程序的步骤: 第一步:编写Linux驱动 第二步:编写HAL Library 第三步:编写 Service Library 编写HAL 模块的步骤和原理如下: 第一步:定义结构体和宏 第二步:编写HAL模块的open函数 第三步:定义hw_module_met			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mm7W6p3.html" rel="bookmark">HAL驱动的串口编程陷阱</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				http://bbs.elecfans.com/jishu_464356_1_1.html 手上有块NUCLEO STM32L053x板子,用来做串口实验,看了下ST的最新库HAL驱动,于是想用HAL驱动来做串口.使用过程中发现只能发送数据不能接收数据,用逻辑分析仪查看RX,TX引角,都有数据,但就是收不到数据.使用STM32F103传统驱动,一点问题没有,改到HAL怎么就不行了呢?经过一周的调试终于找到了问题所在.首先看STM32F103传通驱动的代码: /** USART1 GPIO Con			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lXNrW0.html" rel="bookmark" class="title">星期几的计算 （if语句）</a>
					<div>
						public boolean chackyear(int str) {// 判断平年,闰年 boolean q = str % 4 == 0; boolean w = str % 100 == 0;  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgXlpN0.html" rel="bookmark" class="title">Nginx反向代理、CORS、JSONP等跨域请求解决方法总结</a>
					<div>
						由于 Javascript 同源策略的存在使得一个源中加载来自其它源中资源的行为受到了限制.即会出现跨域请求禁止. 通俗一点说就是如果存在协议.域名.端口或者子域名不同服务端,或一者为IP地址,一者为 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXdzNQM.html" rel="bookmark" class="title">jQuery选择器的总结</a>
					<div>
						jQuery选择器 jQuery选择器是准确地选取你希望应用的元素. jQuery的元素选择器和属性选择器允许你通过标签名.属性名或者内容对HTML元素的选择. jQuery元素选择器表 选择器 实例 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JkgAbM.html" rel="bookmark" class="title">iOS使用AVCaptureSession自定义相机</a>
					<div>
						转自:http://www.2cto.com/kf/201409/335951.html 关于iOS调用摄像机来获取照片,通常我们都会调用UIImagePickerController来调用系统提供的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mg55ZN3.html" rel="bookmark" class="title">Centos linux  安装ffmpeg</a>
					<div>
						1.下载ffmpeg.下载网址:http://www.ffmpeg.org/download.html 2.解压缩tar -zxvf ffmpeg-2.0.1.tar.gz 3.配置,生成Makefi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZAA5J0.html" rel="bookmark" class="title">Charpter8  关于单元测试、集成测试和系统测试我的理解</a>
					<div>
						总体概述 单元测试,是集中对用源代码实现的每一个程序单元进行测试,检查各个程序模块是否正确地实现了规定的功能.集成测试把已测试过的模块组装起来,主要对与设计相关的软件体系结构的构造进行测试.系统测试把 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bYVevM.html" rel="bookmark" class="title">后缀数组-倍增算法模板</a>
					<div>
						void build_sa(int m) { int *x = t, *y = t2; for(int i = 0; i &lt; m; i ++) c[i] = 0; for(int i = 0;  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rvDPw3.html" rel="bookmark" class="title">预加载 img 的方式。</a>
					<div>
						原生方式: var img = new Image(); img.onerror = function() { alert('img error'); }; img.onload = function ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47DWPbM.html" rel="bookmark" class="title">C&sol;C&plus;&plus; 函数调用栈剖析</a>
					<div>
						参考: [1]. C/C++堆栈指引: http://www.cnblogs.com/Binhua-Liu/archive/2010/08/24/1803095.html [2]. C++临时变量的生 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgNRen4.html" rel="bookmark" class="title">SQLHELPER FOR C&num;&period;NET</a>
					<div>
						public class SqliteHelper{ //获取连接字符串 private static readonly string str = ConfigurationManager.Conne ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38wmxR0.html" rel="bookmark" class="title">辛星浅析同源策略</a>
					<div>
						可能平时接触到&quot;跨域&quot;这个概念还是挺频繁的.既然有&quot;跨域&quot;的说法,那么就有&quot;同域&quot;的说法.只是我们一般称之为&quot;同源&quot;.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NGp5yM.html" rel="bookmark" class="title">网络虚拟化初探</a>
					<div>
						数据包从虚拟机到物理机的过程 KVM的网络优化方案,总的思路就是让虚拟机访问物理网卡的层数更少,直至对物理网卡单独占领,和物理机一样使用物理网卡单独占领,和物理机一样使用物理网卡,以达到和物理机一样的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49WZwJ0.html" rel="bookmark" class="title">Linux正则表达式中单引号、双引号及不加引号的区别</a>
					<div>
						1.单引号: 可以说是所见即所得:单引号里面看到的是什么就会输出什么.被单引号括起的内容不管是常量还是变量者不会发生替换. 2.双引号: 把双引号内的内容输出出来,如果内容中有命令.变量等,会先把变量 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OZn7g0.html" rel="bookmark" class="title">走进京东金融：听过来人谈经验及技术干货</a>
					<div>
						以「金融科技」定位的京东金融集团成立于2013年10月,逐步构建了供应链金融.消费金融.财富管理.众筹.证券.保险.支付.金融科技以及农村金融九大业务板块. 京东金融CEO陈生强表示,京东金融以数据为 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qxz5a0.html" rel="bookmark" class="title">Umbraco（4）-Outputting the Document Type Properties（翻译文档）</a>
					<div>
						翻译原文地址:http://www.ncloud.hk/%E6%8A%80%E6%9C%AF%E5%88%86%E4%BA%AB/umbraco4outputting-the-document-typ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBWlZq0.html" rel="bookmark" class="title">js 更换背景图</a>
					<div>
						&lt;!DOCTYPE html&gt; &lt;html&gt; &lt;head lang=&quot;en&quot;&gt; &lt;meta charset=&quot;UTF-8&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xBPwD4.html" rel="bookmark" class="title">ORA-15032、ORA-15071错误处理</a>
					<div>
						遇到一下错误 ERROR at line 1: ORA-15032: not all alterations performed ORA-15071: ASM disk &quot;NOCR_0002 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JjgW94.html" rel="bookmark" class="title">网站访问限制</a>
					<div>
						最近网站一直受到恶意请求和攻击,把最近限制防护历程记录一下: 1.请求次数超过阈值做限制 刚开始网站并没有受到攻击,但有一些恶意抓取网站数据的爬虫,为了防止别人抓取本网站数据,做了请求次数限制,具体思 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPBXry3.html" rel="bookmark" class="title">AppStore应用转让流程</a>
					<div>
						可能大家都有这样的情况,给公司客户开发一个ios app的前期阶段是先发布在自己公司的开发者账户上面的,而不是直接发布在客户的开发者账号上面,这个到后期的话就有一个转让的事情,俗称“过户”. 步骤如下 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M6nrkXM.html" rel="bookmark" class="title">Push flow</a>
					<div>
						自动移库规则push flow可以用来规划物流 比如产品A如果进入到picking区,按照仓储的规则,系统可以自动生产调拨单,将产品A 从picking区调拨到保存的库位货架A1E1 ? ? 设置步骤 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.023 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
